Summary: Generic SPARC linux kernel
Name: kernel-sparc
Version: 2.0.35
Release: 15
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
%define	kversion %{PACKAGE_VERSION}
Copyright: GPL
Group: Base/Kernel
ExclusiveArch: sparc
ExclusiveOS: Linux
Source0: vger.rutgers.edu:/pub/linux/Sparc/kernel/v2.0/980805/sparclinux-2.0-980805.tar.gz
Source1: kernel-config.sparc
Source2: module-info
Source3: rhkmvtag.c
Source4: audio-2.0.35-980829.tar.gz
# patches 0 & 3-5 applied and deleted
Patch1: kernel-smp.patch
Patch2: linux-2.0.33-freemem.patch
# XXX Apply this patch to use CC=sparc-linux-gcc
Patch6: kernel-egcs.patch
Patch7: kernel-2.0.36-rh52.patch
Patch8: kernel-2.0.36-listening.patch
Patch9: kernel-2.0.36-rh521.patch
Patch10: kernel-2.0.36-random.patch
BuildRoot: /var/tmp/%{name}-root
Provides: module-info
Requires: modutils >= 2.1.85-6
Autoreqprov: no

%package smp
Summary: SPARC linux kernel for multiprocessor machines
Group: Base/Kernel

%description smp
This package contains the Linux kernel that is used to boot and run
your system. It includes support for machines with multiple processors,
which will signicicantly improve performance on multiprocessor machines.
It will reduce performance on a single processor machine however. Most 
hardware is instead supported by modules loaded after booting.

%package -n kernel-source
Summary: Kernel source tree
Group: Base/Kernel
Requires: kernel-headers = %{kversion}

%package -n kernel-headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel
Provides: kernel-headers

%description -n kernel-headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description -n kernel-source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%prep
%setup -q -n linux
# add new audio snapshot
%setup -n linux -T -D -a 4

find . -name "*.orig" -print | xargs rm -f

%ifarch sparc
cp $RPM_SOURCE_DIR/kernel-config.sparc arch/sparc/defconfig
%endif

# patches 0 & 3-5 applied and deleted
%patch2 -p1

# XXX Apply this patch to use CC=sparc-linux-gcc
#%patch6 -p1

%patch7 -p1 -b .rh52
%patch8 -p1 -b .listening

%patch9 -p1 -b .rh521
%patch10 -p1 -b .random

# Bring in the Red Hat Kernel Module Version Tag program
cp $RPM_SOURCE_DIR/rhkmvtag.c .

# this is a bit silly, but we happen to have a dual processor sparc
# build machine so what the heck
if [ -f /proc/cpuinfo ]; then
    num=`awk -F: '/ncpus probed/ { print ($2 * 2) + 1; }' /proc/cpuinfo`
    mv Makefile Makefile.onecpu
    sed "s/^MAKE.*=make$/MAKE=make -j $num/" < Makefile.onecpu > Makefile
fi

%build

make oldconfig symlinks
make include/linux/version.h

make vmlinux modules

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
ln -s ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -s ../src/linux/include/scsi $RPM_BUILD_ROOT/usr/include/scsi

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion} $RPM_BUILD_ROOT/boot

install -m644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-%{KVERREL}
install -m644 System.map $RPM_BUILD_ROOT/boot/System.map-%{KVERREL}

strip vmlinux
gzip -9nf vmlinux
install -m755 vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinuz-%{KVERREL}
rm -f vmlinux.gz

mkdir -p $RPM_BUILD_ROOT/lib/modules
make DESTDIR=$RPM_BUILD_ROOT modules_install

# Identify the modules directory with the Red Hat Kernel Module Version Tag
cc -o rhkmvtag rhkmvtag.c init/version.o
./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/%{kversion}/.rhkmvtag
rm -f rhkmvtag

# move the modules to where we like them
mv $RPM_BUILD_ROOT/lib/modules/%{kversion} \
   $RPM_BUILD_ROOT/lib/modules/%{KVERREL}

# now build the SMP flavor

patch -p1 < $RPM_SOURCE_DIR/kernel-smp.patch
make clean Version oldconfig	# nuke include/linux/compile.h for rhkmvtag.

make vmlinux modules

install -m644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-smp-%{KVERREL}
install -m644 System.map $RPM_BUILD_ROOT/boot/System.map-smp-%{KVERREL}

strip vmlinux
gzip -9nf vmlinux
install -m755 vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinuz-smp-%{KVERREL}

make DESTDIR=$RPM_BUILD_ROOT modules_install

# Identify the modules directory with the Red Hat Kernel Module Version Tag
cc -o rhkmvtag rhkmvtag.c init/version.o
./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/%{kversion}/.rhkmvtag
rm -f rhkmvtag

# move the modules to where we like them
mv $RPM_BUILD_ROOT/lib/modules/%{kversion} \
   $RPM_BUILD_ROOT/lib/modules/%{KVERREL}-smp


mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
ln -sf linux-%{kversion} $RPM_BUILD_ROOT/usr/src/linux

cp -a . $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

# keep kernel-source archive clean
make mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make oldconfig -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make symlinks -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make include/linux/version.h -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

#this generates modversions info which we want to include and we may as
#well include the depends stuff as well, after we fix the paths
make depend -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
find $RPM_BUILD_ROOT/usr/src/linux-%{kversion} -name ".*depend" | \
while read file ; do
    mv $file $file.old
    sed -e "s|[^ ]*\(/usr/src/linux\)|\1|g" < $file.old > $file
    rm -f $file.old
done

# make /usr/include/scsi link
mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s /usr/src/linux/include/scsi $RPM_BUILD_ROOT/usr/include/scsi

%clean
rm -rf $RPM_BUILD_ROOT

%preun
rm -f /lib/modules/%{KVERREL}/modules.dep

%preun smp
rm -f /lib/modules/%{KVERREL}-smp/modules.dep

%post -n kernel-headers
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux

%postun -n kernel-headers
if [ -L /usr/src/linux ]; then
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
	[ $1 = 0 ] && rm -f /usr/src/linux
    fi
fi

%files
%defattr(-,root,root)
/boot/vmlinuz-%{KVERREL}
/boot/module-info-%{KVERREL}
/boot/System.map-%{KVERREL}
%dir /lib/modules
%dir /lib/modules/%{KVERREL}
/lib/modules/%{KVERREL}/.rhkmvtag
/lib/modules/%{KVERREL}/block
/lib/modules/%{KVERREL}/fs
/lib/modules/%{KVERREL}/ipv4
/lib/modules/%{KVERREL}/misc
/lib/modules/%{KVERREL}/net
/lib/modules/%{KVERREL}/scsi

%files smp
%defattr(-,root,root)
/boot/vmlinuz-smp-%{KVERREL}
/boot/module-info-smp-%{KVERREL}
/boot/System.map-smp-%{KVERREL}
%dir /lib/modules
%dir /lib/modules/%{KVERREL}-smp
/lib/modules/%{KVERREL}-smp/.rhkmvtag
/lib/modules/%{KVERREL}-smp/block
/lib/modules/%{KVERREL}-smp/fs
/lib/modules/%{KVERREL}-smp/ipv4
/lib/modules/%{KVERREL}-smp/misc
/lib/modules/%{KVERREL}-smp/net
/lib/modules/%{KVERREL}-smp/scsi

%files -n kernel-source
%defattr(-,root,root)
%dir /usr/src/linux-%{kversion}
/usr/src/linux-%{kversion}/COPYING
/usr/src/linux-%{kversion}/CREDITS
/usr/src/linux-%{kversion}/Documentation
/usr/src/linux-%{kversion}/MAINTAINERS
/usr/src/linux-%{kversion}/Makefile
/usr/src/linux-%{kversion}/README
/usr/src/linux-%{kversion}/Rules.make
/usr/src/linux-%{kversion}/arch
/usr/src/linux-%{kversion}/drivers
/usr/src/linux-%{kversion}/fs
/usr/src/linux-%{kversion}/init
/usr/src/linux-%{kversion}/ipc
/usr/src/linux-%{kversion}/kernel
/usr/src/linux-%{kversion}/lib
/usr/src/linux-%{kversion}/mm
/usr/src/linux-%{kversion}/modules
/usr/src/linux-%{kversion}/net
/usr/src/linux-%{kversion}/scripts

%files -n kernel-headers
%defattr(-,root,root)
/usr/src/linux-%{kversion}/include/asm
/usr/src/linux-%{kversion}/include/asm-generic
/usr/src/linux-%{kversion}/include/linux
/usr/src/linux-%{kversion}/include/net
/usr/src/linux-%{kversion}/include/scsi
/usr/include/asm
/usr/include/linux
/usr/include/scsi
/usr/src/linux-%{kversion}/include/asm-%{buildarch}

%changelog
* Wed Dec 30 1998 Jeff Johnson <jbj@redhat.com>
- enable latest audio driver.
- /dev/random fixes.

* Tue Nov 17 1998 Jeff Johnson <jbj@redhat.com>
- security fixes from official 2.0.36

* Wed Nov  4 1998 Bill Nottingham <notting@redhat.com>
- add newer audio snapshot

* Mon Oct  5 1998 Jeff Johnson <jbj@redhat.com>
- apply 2.0.36 patches from Alan Cox.

* Tue Sep  8 1998 Jeff Johnson <jbj@redhat.com>
- enable audio modules.

* Wed Sep  2 1998 Jeff Johnson <jbj@redhat.com>
- update to 980805.
- revert to using egcs to compile.

* Sat Aug 29 1998 Jeff Johnson <jbj@redhat.com>
- port Christian's 2.1 style build back to 2.0.35.

* Thu Aug 13 1998 Jeff Johnson <jbj@redhat.com>
- nuke the /boot symlinks. eliminate %post silo too.
- add %preun modules.dep removal

* Tue Jul 28 1998 Jeff Johnson <jbj@redhat.com>
- the SMP kernel package needs different .rhkmvtag

* Mon Jul 27 1998 Jeff Johnson <jbj@redhat.com>
- add /lib/modules/*/scsi/*

* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- update to 980719.

* Tue Jul 14 1998 Jeff Johnson <jbj@redhat.com>
- hardwire CC="sparc-redhat-linux-gcc".
- update to 980712.

* Thu Jul  2 1998 Jeff Johnson <jbj@redhat.com>
- Add rhkmvtag identification.
- Kernel config changes (more like i386):
	y->m: MD_LINEAR/MD_STRIPED/CHAR_DEV_ST/CHAR_DEV_SG
	n->y: IP_TRANSPARENT_PROXY/IP_ACCT/IP_FIREWALL_VERBOSE
	y->n: IP_MASQUERADE_IPAUTOFW

* Mon Jun  1 1998 David S. Miller <davem@dm.cobaltmicro.com>
- Add -mno-fpu to sparc Makefile, needed for egcs

* Fri May 22 1998 Jeff Johnson <jbj@redhat.com>
- Follow new /boot naming conventions.
- Bundle modules with kernels.

* Thu May 21 1998 Jeff Johnson <jbj@redhat.com>
- Package for 5.1.
